<!doctype html>
<html>
  <body>
    <h2>Interface Utilisateur Native</h2>

  L'interface utilisateur <i>Android</i> est introduite selon les points suivants :
    <ul>
      <li>Configuration d'une vue</li>
      <li>Gestion du clique sur un bouton</li>
    </ul></p>
    <p>
<h3>Configuration d'une vue</h3>
<p>Une vue affiche des éléments graphiques à l'écran, elle représente l'interface utilisateur.
  Elle est soit statique, décrite dans un fichier XML, soit dynamique, décrite dans
  du code <i>Kotlin</i> via une classe héritant de <code>View</code>.<br>
  Un projet <i>Android</i> suit le design pattern MVC (Modèle Vue Contrôleur) :
  la vue est contenue dans un fichier XML du dossier <code>layout/</code>,
  tandis que le contrôleur est représenté par l'<code>Activity</code>.<br>
  En effet, en général, le fichier XML est utilisé pour définir l'interface graphique,
  et le code <i>Kotlin</i> intercepte les interactions sur les éléments graphiques,
  déclarés dans ce fichier XML.</p>
  <p>Dans le premier projet (cf. <a href="file:///android_asset/1D-premierprojet.html">partie ABCD Android</a>), l'activité principale est
  la classe <code>MainActivity</code>, elle hérite de <code>AppCompatActivity</code>.
  Cette dernière est une <code>Activity</code>, représentant un écran, compatible
  avec les anciennes versions d'<i>Android</i>.<br>
  La vue est décrite dans un fichier XML, <code>activity_main.xml</code> :
  <textarea rows="20" cols="40" style="border:none;">
    <?xml version="1.0" encoding="utf-8"?>
   <LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
       android:layout_width="match_parent"
       android:layout_height="match_parent"
       android:orientation="vertical">

       <TextView
       android:layout_width="wrap_content"
       android:layout_height="wrap_content"
       android:text="Hello Kotlin!" />

   </LinearLayout>
  </textarea>
  Remarque : pour des raisons pratiques, il est utilisé le modèle
  d'agancement <code>LinearLayout</code> plutôt que le <code>ConstraintLayout</code>.
  En effet, ce modèle permet d'agencer simplement les éléments graphiques de manière linéaire
  (sans se préocuper d'attributs de placements, nécéssaires avec les autres types d'agencements).</p>
  <p>Le fichier XML <code>activity_main.xml</code> possède une structure d'arbre :
  il contient à la racine un <code>LinearLayout</code>, ce dernier contient
  alors tous les éléments graphiques à afficher dans la vue.</p>
  <p>Chaque élément graphique, possède obligatoirement les attributs <code>layout_width</code>
  et <code>layout_height</code>.<br>
  Ils peuvent prendre pour valeur :
  <ul>
    <li><code>match_parent</code> : correspond à la taille de l'élément parent,
      soit la taille de l'écran.</li>
    <li><code>wrap_content</code> : correspond à la taille de l'élément courant.</li>
    <li><code>120dp</code> : une dimension fixe indépendante du pixel et donc de
      la taille de l'écran (dp signifie <i>density independant pixel</i>).</li>
  </ul>
  Le système <i>Android</i> gère l'affichage de l'interface sur tous les
  <i>smartphones</i> quelque soit leur dimension en pixel, grâce à la dimension <i>dp</i>.
</p>
  <p>L'<code>Activity</code> est liée à la vue, dans la méthode <code>onCreate()</code> via l'appel de
  la fonction <code>setContentView</code>, prenant en paramètre l'identifiant du fichier XML, <code>R.layout.activity_main</code> :<br>
  <pre>
  <code>
    class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
    }
}
  </code>
</pre></p>

<h3>Gestion du clique sur un bouton</h3>
<p>Dans cette partie, l’objectif est d'afficher un message rapide lorsque l'utilisateur
clique sur un bouton.</p>
<ol>
  <li>Créez un nouveau projet <i>Android Studio</i>, dont l'<code>Activity</code>
    principale est <code>MainActivity</code>, avec le modèle <code>EmptyActivity</code>.</li>
    <li>Placez vous dans la vue, soit le fichier <code>activity_main.xml</code>
      situé dans le dossier <code>layout/</code></li>
    <li>Changez le <i>layout</i> principale <i>ConstraintLayout</i> en <i>LinearLayout</i>.
      Cela, afin de s'affranchir des attributs de placement complexes liés au
      <i>ConstraintLayout</i>.</li>
    <li>Ajoutez-y un bouton dont l'identifiant est <code>mainButton</code>,
    soit via l’éditeur graphique intégré à <i>Android Studio</i>,
soit directement dans le fichier XML (en passant en mode <i>Text</i> plutôt que
 <i>Design</i> via le menu situé en bas du fichier) :
<textarea rows="16" cols="40" style="border:none;">
<?xml version="1.0" encoding="utf-8"?>
<LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
  android:layout_width="match_parent"
  android:layout_height="match_parent"
  android:orientation="vertical">

     <Button
     android:id="@+id/mainButton"
     android:layout_width="wrap_content"
     android:layout_height="wrap_content"
     android:text="Click me!" />

 </LinearLayout>
</textarea>
Remarquez l’annotation <code>@+id/</code> pour la déclaration d’un nouvel identifiant XML.<br>
Ici <code>wrap_content</code> correspond à la taille du texte du bouton "Click me!"
</li>
<li>Placez vous dans la classe principale de votre projet : <code>MainActivity</code>,
  en particulier dans la méthode <code>onCreate()</code>.
Vous pouvez à présent, accéder à l’élément graphique de type <code>Button</code>,
via la variable <code>mainButton</code>, dans le code <i>Kotlin</i>.
Introduisez la variable <code>mainButton</code> dans la méthode <code>onCreate()</code> :
<pre>
<code>
   ...
   override fun onCreate(savedInstanceState: Bundle?) {
     super.onCreate(savedInstanceState)
     setContentView(R.layout.activity_my_main)
     mainButton
   }
   ...
 </code>
 </pre>
<i>Android Studio</i> devrait vous proposer d'importer le fichier XML,
<code>activity_main.xml</code>, via les extensions <i>Kotlin</i> :
<pre>
<code>
 import kotlinx.android.synthetic.main.activity_main.*
</code>
</pre>
</li>
<li>Interceptez le clique sur le bouton, via la fonction lambda <code>setOnClickListener { }</code>
   et affichez un message rapide via la création d'un <i>Toast</i> :
  <pre>
  <code>
mainButton.setOnClickListener {
Toast.makeText(this, "Hello Kotlin!", Toast.LENGTH_SHORT).show()
}
</code>
</pre>
  <li>Enfin, après exécution du projet, vous devriez voir s’afficher à l’écran
    un bouton et une popup lorsque vous cliquez dessus.</li>
</ol>
<h4>Partie suivante</h4>
<a href="file:///android_asset/4-agencement.html">Les agencements</a>
  </body>
</html>
